
;; Loads the condition stuff, which I only use to define IGNORE-ERRORS
;; at the end of this file.

(provide "conditions")

(defvar *base-directory* "/var/tmp/robot/")

(eval-when (load eval compile)

(defun jamie-load-clcs (&optional (mode :compiled))
  (let ((files (list 
		"package"
		"precom"
		"macros"
		"restart"
		"handler"
		"debugger"
		"conditions"
		"condition-definitions"
		"kcl-cond"
		"top-patches"
		"install")))
    (when (eql :compile mode)
	  (load-base "clcs/package.lisp")
	  (load-base "clcs/precom.lisp"))
    (mapc #'(lambda (file)
	      (ecase mode
		     (:interpreted (load-base (format nil "clcs/~A.lisp" file)))
		     (:compiled (load-base (format nil "clcs/~A.o" file)))
		     (:compile (compile-file (format nil "~aclcs/~A.lisp" *base-directory* file)))))
	  files)))

(jamie-load-clcs)

)

(defun n-values (n)
  (cons 'values (make-list n)))

(defmacro ignore-errors (form)
  `(conditions::handler-case ,form (t nil)))
