Changes: 

@begin(enumerate)
In support of timing analysis, each node upon entry will reset the
variable node-counter to 0.  Which means we need to add back in local
variables on a per node basis.

A new pattern matching event, NOTIFY.
@end(enumerate)

@begin(format,leftmargin +.25)@tabset(1.25inch,3.5inch)

prime @\-> symbol : (member symbol prim-evs)
var   @\-> symbol : (assoc form vars)
state @\-> symbol : (member name states)
fun   @\-> symbol : (fboundp f)

cond  @\-> var
      @\-> (IN state) 
      @\-> (op1 n n)             @\: op1   @\-> EQ | NEQ | < | >
      @\-> (op2 string string)   @\: op2   @\-> EQ | NEQ  
      @\-> (NOT cond)
      @\-> (AND . cond*) 
      @\-> (OR . cond*) 
      @\-> (fun . args)     

Event Expressions

event @\-> prime
      @\-> ( NOTIFY command )         @\: Commands follow syntax determined by MOO and
                                    @\: MOO-moderated tools.
      @\-> ( NOTIFY pat )             @\: Used by charts to match events. 
      @\-> ( NODE-COUNT name n )      @\: True if (node-ticks (find-node name config)) >= n
      @\-> ( [ ENTERED | EXITED ] state)
      @\-> ( [ CHANGED | READ | WRITTEN ] var)
      @\-> ( [ TRUE | FALSE] cond)
      @\-> ( TIMEOUT n event)         @\: N clock units passed since event (exactly?)
      @\-> ( COND event cond )        @\: Event occurred and C is true
      @\-> ( NOT event )
      @\-> ( AND . event*)
      @\-> ( OR . event*)
      @\-> ( fun . args)     

pat   @\-> nil                  @\: No NOTIFY event occurred.
      @\-> *                    @\: Any NOTIFY event occurred.
      @\-> symbol               @\: Command of notify event must match symbol.  
                              @\: At the moment this means (car com) = symbol. 
      @\-> ( - pat )            @\: True if event does not match pattern 
      @\-> ( symbol [ part* ] ) @\: Symbol must be equal to event car
                              @\: Parts must match initial sublist.

part  @\-> *                    @\: Wildcard match (in this context, matches NIL)
      @\-> atom                 @\: = 
      @\-> ( part [ part* ] )

Action Expressions

action @\-> prime
       @\-> ( [ MAKE-TRUE | MAKE-FALSE ] var)
       @\-> ( ASSIGN var expr )
       @\-> ( [ READ-DATA | WRITE-DATA ] var )
       @\-> ( SCHEDULE n action )     @\: Perform action delayed by N clock units
       @\-> ( PAR . action* )
       @\-> ( IF cond action [ action ] )
       @\-> ( WHEN event action [ action ] )
       @\-> ( fun . args)     

Numeric Expressions can include the following operations:

(EXPT n n)  @\-> n
(* n n)    @\-> n
(/ n n)    @\-> n
(+ n n)    @\-> n
(- n n)    @\-> n
(- n)      @\-> n

(MAX . i)  @\-> i
(MIN . i)  @\-> i
(ABS i)    @\-> i
(MOD i i)  @\-> i

RANDOM is variant!  Statemate returns real.

(RANDOM i) @\-> i  @\: result in [0..arg] 

Not yet implemented

(TRUNC i)  @\-> r
(BNOT i)   @\-> i
(bvop i i) @\-> i : bvop in BAND BOR BXOR BNAND BNOR

@end(format)
